
disp('Problem 2c:')

maxit=500;

% call Jacobi method with m=7 and maxit iterations:
[Jerrv,Jerrvh]=lap2d_jacobi(7,maxit);

% The following plots the convergence history of the Jacobi method using
% logarithmic scaling for the error between the exact and iterative
% solutions. 
figure(2)
it = 1:length(Jerrv);
plot(it,log2(Jerrv),'b-')
hold on;

% The following plots the convergence history of the Jacobi method using
% logarithmic scaling for the error between the direct and iterative
% solutions. 
figure(3)
it = 1:length(Jerrvh);
plot(it,log2(Jerrvh),'b-')
hold on;

% call Gauss-Seidel method with m=7 and maxit iterations:
[GSerrv,GSerrvh]=lap2d_gs(7,maxit);

% The following plots the convergence history of the Gauss-Seidel method using
% logarithmic scaling for the error between the exact and iterative
% solutions. 
figure(2)
it = 1:length(GSerrv);
plot(it,log2(GSerrv),'r--')
hold on;

% The following plots the convergence history of the Gauss-Seidel method using
% logarithmic scaling for the error between the direct and iterative
% solutions. 
figure(3)
it = 1:length(GSerrvh);
plot(it,log2(GSerrvh),'r--')
hold on;

% call SOR method with m=7 and maxit iterations:
[SORerrv,SORerrvh,errd7]=lap2d_sor(7,maxit);
disp(sprintf(...
'  Error between exact and direct for m=%d is 2^%g.',7,log2(errd7)))

% The following plots the convergence history of the SOR method using
% logarithmic scaling for the error between the exact and iterative
% solutions. 
figure(2)
it = 1:length(SORerrv);
plot(it,log2(SORerrv),'g-.')
hold on;

% The following plots the convergence history of the SOR method using
% logarithmic scaling for the error between the direct and iterative
% solutions. 
figure(3)
it = 1:length(SORerrvh);
plot(it,log2(SORerrvh),'g-.')
hold on;

% add title, labels, and legends to the above plots
figure(2)
title(sprintf(...
    'Error between iterative solution and exact solution with m=%d',7))
xlabel('Iteration number')
ylabel('log_2(error)')
legend('Jacobi','Gauss-Seidel','SOR');

figure(3)
title(sprintf(...
    'Error between iterative solution and direct solution with m=%d',7))
xlabel('Iteration number')
ylabel('log_2(error)')
legend('Jacobi','Gauss-Seidel','SOR');


maxit=2000;
% call Jacobi method with m=15 and maxit iterations:
[Jerrv,Jerrvh]=lap2d_jacobi(15,maxit);

% The following plots the convergence history of the Jacobi method using
% logarithmic scaling for the error between the exact and iterative
% solutions.
figure(4)
it = 1:length(Jerrv);
plot(it,log2(Jerrv),'b-')
hold on;

% The following plots the convergence history of the Jacobi method using
% logarithmic scaling for the error between the direct and iterative
% solutions. 
figure(5)
it = 1:length(Jerrvh);
plot(it,log2(Jerrvh),'b-')
hold on;

% call Gauss-Seidel method with m=15 and maxit iterations:
[GSerrv,GSerrvh]=lap2d_gs(15,maxit);

% The following plots the convergence history of the Gauss-Seidel method using
% logarithmic scaling for the error between the exact and iterative
% solutions. 
figure(4)
it = 1:length(GSerrv);
plot(it,log2(GSerrv),'r--')
hold on;

% The following plots the convergence history of the Gauss-Seidel method using
% logarithmic scaling for the error between the direct and iterative
% solutions. 
figure(5)
it = 1:length(GSerrvh);
plot(it,log2(GSerrvh),'r--')
hold on;

% call SOR method with m=15 and maxit iterations:
[SORerrv,SORerrvh,errd15]=lap2d_sor(15,maxit);
disp(sprintf(...
'  Error between exact and direct for m=%d is 2^%g.',15,log2(errd15)))
disp(sprintf(...
'  Ratio between errors from m=%d and m=%d is %g.',7,15,errd7/errd15))

% The following plots the convergence history of the SOR method using
% logarithmic scaling for the error between the exact and iterative
% solutions. 
figure(4)
it = 1:length(SORerrv);
plot(it,log2(SORerrv),'g-.')
hold on;

% The following plots the convergence history of the SOR method using
% logarithmic scaling for the error between the direct and iterative
% solutions. 
figure(5)
it = 1:length(SORerrvh);
plot(it,log2(SORerrvh),'g-.')
hold on;


% add title, labels, and legends to the above plots
figure(4)
title(sprintf(...
    'Error between iterative solution and exact solution with m=%d',15))
xlabel('Iteration number')
ylabel('log_2(error)')
legend('Jacobi','Gauss-Seidel','SOR');

figure(5)
title(sprintf(...
    'Error between iterative solution and direct solution with m=%d',15))
xlabel('Iteration number')
ylabel('log_2(error)')
legend('Jacobi','Gauss-Seidel','SOR');

figure(4)
disp('Jacobi has smallest error, while SOR is fastest to converge.')
pause


figure(5)
disp('Problem 2d:')
disp('Discretization error is left over, it should be order h^2.')
disp('Plots show iterative solution is converging to direct solution.')
pause

disp('Problem 2e:')
disp('Seems that error=h^2/3.5, in general we cannot compute errors.')
maxit=500;
m=7;
h=1/(m+1);
tol=h^2/3.5;

% call Jacobi method
[Jerrv,Jerrvh]=lap2d_jacobi(m,maxit,tol);

% The following plots the convergence history of the Jacobi method using
% logarithmic scaling for the error between the exact and iterative
% solutions. 
figure(6)
it = 1:length(Jerrv);
plot(it,log2(Jerrv),'b-')
hold on;

% call Gauss-Seidel method
[GSerrv,GSerrvh]=lap2d_gs(m,maxit,tol);

% The following plots the convergence history of the Gauss-Seidel method using
% logarithmic scaling for the error between the exact and iterative
% solutions. 
figure(6)
it = 1:length(GSerrv);
plot(it,log2(GSerrv),'r--')
hold on;

% call SOR method
[SORerrv,SORerrvh]=lap2d_sor(m,maxit,tol);

% The following plots the convergence history of the SOR method using
% logarithmic scaling for the error between the exact and iterative
% solutions. 
figure(6)
it = 1:length(SORerrv);
plot(it,log2(SORerrv),'g-.')
hold on;

% add title, labels, and legends to the above plots
figure(6)
title(sprintf(...
    'Error between iterative solution and exact solution with m=%d',m))
xlabel('Iteration number')
ylabel('log_2(error)')
legend('Jacobi','Gauss-Seidel','SOR');


maxit=2000;
m=15;
h=1/(m+1);
tol=h^2/3.5;
% call Jacobi method
[Jerrv,Jerrvh]=lap2d_jacobi(m,maxit,tol);

% The following plots the convergence history of the Jacobi method using
% logarithmic scaling for the error between the exact and iterative
% solutions.
figure(7)
it = 1:length(Jerrv);
plot(it,log2(Jerrv),'b-')
hold on;

% call Gauss-Seidel method
[GSerrv,GSerrvh]=lap2d_gs(m,maxit,tol);

% The following plots the convergence history of the Gauss-Seidel method using
% logarithmic scaling for the error between the exact and iterative
% solutions. 
figure(7)
it = 1:length(GSerrv);
plot(it,log2(GSerrv),'r--')
hold on;

% call SOR method
[SORerrv,SORerrvh]=lap2d_sor(m,maxit,tol);

% The following plots the convergence history of the SOR method using
% logarithmic scaling for the error between the exact and iterative
% solutions. 
figure(7)
it = 1:length(SORerrv);
plot(it,log2(SORerrv),'g-.')
hold on;

% add title, labels, and legends to the above plots
figure(7)
title(sprintf(...
    'Error between iterative solution and exact solution with m=%d',m))
xlabel('Iteration number')
ylabel('log_2(error)')
legend('Jacobi','Gauss-Seidel','SOR');

% run for each m value
maxit=10000;
mv=[3,7,15,31,63];
iv=[1:length(mv)];
for i=iv,
  m=mv(i);
  h=1/(m+1);
  tol=h^2/3.5;
  [Jerrv,Jerrvh]=lap2d_jacobi(m,maxit,tol);
  Jit(i)=length(Jerrv);
  [GSerrv,GSerrvh]=lap2d_gs(m,maxit,tol);
  GSit(i)=length(GSerrv);
  [SORerrv,SORerrvh]=lap2d_sor(m,maxit,tol);
  SORit(i)=length(SORerrv);
end
figure(8)
plot(mv,Jit,'b-*',mv,GSit,'r--o',mv,SORit,'g-.s');
title('Number of iterations required to achieve minimum error');
xlabel('m')
ylabel('k')
legend('Jacobi','Gauss-Seidel','SOR','Location','Best');

figure(9)
plot(log2(mv),log2(Jit./log2(mv)),'b-*',...
     log2(mv),log2(GSit./log2(mv)),'r--o',...
     log2(mv),log2(SORit./log2(mv)),'g-.s');
title('Number of iterations required to achieve minimum error/log2(m)');
xlabel('log_2(m)')
ylabel('log_2(k/log_2(m))')
legend('Jacobi','Gauss-Seidel','SOR');
axis('tight')
axis('equal')
disp('Iterations for Jacobi is twice that of GS.')
disp(['From the log plot we see that SOR is first order, while', ...
      ' Jacobi and GS are quadractic'])

pause
disp('Problem 2f:')
% run for each m value
maxit=10000;
mv=[3,7,15,31,63];
iv=[1:length(mv)];
for i=iv,
  m=mv(i);
  h=1/(m+1);
  tol=h^2/3.5;
  [Jerrv,Jerrvh]=lap2d_jacobi(m,maxit,tol);
  Jer(i)=Jerrv(end);
  [GSerrv,GSerrvh]=lap2d_gs(m,maxit,tol);
  GSer(i)=GSerrv(end);
  [SORerrv,SORerrvh]=lap2d_sor(m,maxit,tol);
  SORer(i)=SORerrv(end);
end
figure(10)
plot(log2(1./(mv+1)),log2(Jer),'b-*',...
     log2(1./(mv+1)),log2(GSer),'r--o',...
     log2(1./(mv+1)),log2(SORer),'g-.s');
title('Minimum possible error for each h');
xlabel('log_2(h)')
ylabel('log_2(error)')
legend('Jacobi','Gauss-Seidel','SOR');
axis('tight')
axis('equal')

disp(['All methods have second order convergence inherited from',...
     ' the finite difference scheme.'])
